﻿using Sandbox.Common.Components;
using Sandbox.Common.ObjectBuilders;
using Sandbox.Game.Entities;
using Sandbox.ModAPI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ThrustUpgrade
{
    [MyEntityComponentDescriptor(typeof(MyObjectBuilder_Thrust))]
    public class MyThrusterUpgradeLogic : MyGameLogicComponent
    {
        private IMyThrust m_thrust;
        private Sandbox.ModAPI.IMyCubeBlock m_parent;
        private MyObjectBuilder_EntityBase m_objectBuilder = null;

        public override void Init(MyObjectBuilder_EntityBase objectBuilder)
        {
            base.Init(objectBuilder);

            m_thrust = Entity as IMyThrust;
            m_parent = Entity as Sandbox.ModAPI.IMyCubeBlock;

            m_parent.UpgradeValues.Add("Thrust", 0f);

            m_objectBuilder = objectBuilder;

            m_parent.OnUpgradeValuesChanged += OnUpgradeValuesChanged;
        }

        public override MyObjectBuilder_EntityBase GetObjectBuilder(bool copy = false)
        {
            return m_objectBuilder;
        }

        private void OnUpgradeValuesChanged()
        {
            m_thrust.ThrustMultiplier = m_parent.UpgradeValues["Thrust"] + 3f;
            m_thrust.PowerConsumptionMultiplier = m_parent.UpgradeValues["Thrust"] + 0.3f;
        }
    }
}
